﻿<?
	$server = $_POST["server"];
	$protocol = $_POST["protocol"];
	
	if($server == "")
		print("Задайте адрес сервера");
	else if($protocol == "NTP")
	{
		print("Протокол NTP, сервер $server\n\n");
		$fp = fsockopen("udp://".$server, 123);
		if (!$fp)
			die("Не удалось соединиться с сервером\n");
		$req = "";
		for($i=0;$i<48;$i++)
			$req = $req.chr(0);
		$req[0] = chr(0xD9);
		print ("Запрос:\n".StrToHex($req, 48)."\n");
		ShowNTP($req);
		fwrite($fp, $req);
		$ans = fread($fp, 48);
		print ("\nОтвет:\n".StrToHex($ans, 48)."\n");
		ShowNTP($ans);
	}
	else if($protocol == "TIME")
	{
		print("Протокол TIME, сервер $server\n\n");
		$fp = fsockopen("tcp://".$server, 37);
		if (!$fp)
			die("Не удалось соединиться с сервером\n");
		$req = "";
		print ("Запрос: (пустая строка)\n$req");
		fwrite($fp, $req);
		$ans = fread($fp, 4);
		print ("\nОтвет:\n");
		PrintU32($ans, 0);
		echo date(DATE_RFC2822, $n - 2208988800);
		fclose($fp);
	}
	else if($protocol == "DAYTIME")
	{
		print("Протокол DAYTIME, сервер $server\n\n");
		$fp = fsockopen("tcp://".$server, 13);
		if (!$fp)
			die("Не удалось соединиться с сервером\n");
		$req = "";
		print ("Запрос: (пустая строка)\n$req");
		fwrite($fp, $req);
		$ans = fread($fp, 1000);
		print ("\nОтвет:\n$ans");
		fclose($fp);
	}
	else if($protocol == "HTTP")
	{
		print("Протокол HTTP, сервер $server\n\n");
		$fp = fsockopen("tcp://".$server, 80);
		if (!$fp)
			die("Не удалось соединиться с сервером\n");
		$req = "HEAD / HTTP/1.1\r\n".
			   "Host: $server\r\n\r\n";
		print ("Запрос:\n$req");
		fwrite($fp, $req);
		$ans = fread($fp, 1000);
		print ("\nОтвет:\n$ans");
		fclose($fp);
	}
	else
		echo "Неизвестный протокол";
	
	function PrintU8($buf, $offset)
	{
		$n = ord($buf[$offset]);
		printf("%02X",$n);
		printf(" (%02u): ",$n);
		return $n;
	}
	
	function PrintS8($buf, $offset)
	{
		$n = ord($buf[$offset]);
		printf("%02X",$n);
		if($n > 0x7F)
			$n = $n - 0xFF - 1;
		printf(" (%02d): ",$n);
		return $n;
	}
	
	function StrToHex($buf, $len)
	{
		$res = "";
		for($i=0;$i<$len;$i++)
		{
			$res = $res.sprintf("%02X",ord($buf[$i]));
			if( ($i != 0) && ($i%32 == 0) )
				$res = $res."\n";
		}
		return $res;
	}
	
	function PrintHex($buf, $offset, $len)
	{
		for($i=$offset;$i<$offset+$len;$i++)
			printf("%02X",ord($buf[$i]));
		print(": ");
	}
		
	function PrintU32($buf, $offset)
	{
		$n = 0;
		for($i=$offset;$i<$offset+4;$i++)
		{
			$b = ord($buf[$i]);
			$n *= 256;
			$n += $b;
			printf("%02X",$b);
		}
		printf(" (%u): ",$n);
		return $n;
	}
	
	function StrToU32($buf, $offset)
	{
		$n = 0;
		for($i=$offset;$i<$offset+4;$i++)
		{
			$b = ord($buf[$i]);
			$n *= 256;
			$n += $b;
		}
		return $n;
	}
	
	function PrintS32($buf, $offset)
	{
		$n = 0;
		for($i=$offset;$i<$offset+4;$i++)
		{
			$b = ord($buf[$i]);
			$n *= 256;
			$n += $b;
			printf("%02X",$b);
		}
		if($n > 0x7FFFFFFF)
			$n = $n - 0xFFFFFFFF - 1;
		printf(" (%d): ",$n);
		return $n;
	}
	
	function CalcPower2($n)
	{
		$p = 1;
		if($n > 0)
		{
			if($n > 32) $n = 32;
			for($i=0;$i<$n;$i++)
				$p *= 2;
		}
		if($n <= 0)
		{
			$n = -$n;
			if($n > 32) $n = 32;
			for($i=0;$i<$n;$i++)
				$p /= 2;
		}
		return $p;
	}
	
	function PrintTimeStamp($buf, $offset, $name)
	{
		PrintHex($buf, $offset, 8);
		print($name."\n");
		$a = StrToU32($buf, $offset);
		$b = StrToU32($buf, $offset+4);
		print(" ".date(DATE_RFC2822, $a - 2208988800)." ".$b/CalcPower2(32)."\n");
	}
		
	function ShowNTP($buf)
	{
		$li_descr = array ( 0 => "нет предупреждения", 1 => "+1 сек", 2 => "-1 сек", 3 => "часы не синхронизированы");
		$mode_descr = array( 0 => "зарезервировано", 1 => "symmetric active", 2 => "client", 3 => "server",
							 4 => "broadcast", 5 => "NTP control message");
		$stratum_descr = array( 0 => "не указан", 1 => "первичный", 2 => "вторичный");
		$offset = 0;
		// Flags
		$n = PrintU8($buf, $offset);
		print ("Flags\n");
		print (" Leap Indicator: ".$li_descr[$n>>6]."\n");
		print (" Version number: ".(($n>>3)&0x07)."\n");
		print (" Mode: ".$mode_descr[$n&0x07]."\n");
		$offset += 1;
		// Peer Clock Stratum
		$stratum = PrintU8($buf, $offset); if($n > 2) $n = 2;
		print ("Peer Clock Stratum \n ".$stratum_descr[$stratum]."\n");
		$offset += 1;
		// Peer Polling Interval
		$n = PrintS8($buf, $offset);
		print ("Peer Polling Interval \n ".CalcPower2($n)." сек\n");
		$offset += 1;
		// Peer Clock Precision
		$n = PrintS8($buf, $offset);
		print ("Peer Clock Precision \n ".CalcPower2($n)." сек\n");
		$offset += 1;
		// Root Delay
		$n = PrintS32($buf, $offset);
		print ("Root Delay \n ".$n/CalcPower2(16)." сек\n");
		$offset += 4;
		// Root Dispersion
		$n = PrintS32($buf, $offset);
		print ("Root Dispersion \n ".$n/CalcPower2(16)." сек\n");
		$offset += 4;
		// Reference ID
		PrintHex($buf, $offset, 4);
		print ("Reference ID \n");
		if($stratum == 1)
			print(" ".substr($buf, $offset, 4)."\n");
		else
			printf(" %u.%u.%u.%u\n", ord($buf[$offset]),ord($buf[$offset+1]),ord($buf[$offset+2]),ord($buf[$offset+3]));
		$offset += 4;
		// Reference Timestamp
		PrintTimeStamp($buf, $offset, "Reference Timestamp");
		$offset += 8;
		// Origin Timestamp
		PrintTimeStamp($buf, $offset, "Origin Timestamp");
		$offset += 8;
		// Receive Timestamp
		PrintTimeStamp($buf, $offset, "Receive Timestamp");
		$offset += 8;
		// Transmit Timestamp
		PrintTimeStamp($buf, $offset, "Transmit Timestamp");
		$offset += 8;
	}
?>